<template>
  <div>
    <v-card class="text-center pa-1">
      <v-card-title class="justify-center display-1 mb-2">Welcome</v-card-title>
      <v-card-subtitle>Sign in to your account</v-card-subtitle>

      <!-- sign in form -->
      <v-card-text>
        <v-form ref="form" v-model="isFormValid" lazy-validation>
          <v-text-field
            v-model="credentials.email"
            :rules="[rules.required]"
            :validate-on-blur="false"
            :error="error"
            :label="$t('login.email')"
            name="email"
            outlined
            @keyup.enter="submit"
            @change="resetErrors"
          ></v-text-field>
           <!-- <v-select
            v-model="credentials.Role"
            :label="$t('login.role')"
            :items="
              Role.map(({ name, value }) => ({
                text: name,
                value: value,
              }))
            "
            width="10%"
            style="margin: 18px 0 0 0"

            outlined
            dense
          ></v-select>
          <v-select
            v-model="credentials.Type"
            :label="$t('login.typeOfRejesteration')"
            :items="
              Type.map(({ name, value }) => ({
                text: name,
                value: value,
              }))
            "
            width="10%"
            style="margin: 18px 0 0 0"

            outlined
            dense
          ></v-select> -->
          <v-text-field
            v-model="credentials.password"
            :append-icon="showPassword ? 'mdi-eye' : 'mdi-eye-off'"
            :rules="[rules.required]"
            :type="showPassword ? 'text' : 'password'"
            :error="error"
            :error-messages="errorMessages"
            :label="$t('login.password')"
            name="password"
            outlined
            @change="resetErrors"
            @keyup.enter="submit"
            @click:append="showPassword = !showPassword"
          ></v-text-field>

          <v-btn
            :loading="isLoading"
            :disabled="isSignInDisabled"
            block
            x-large
            color="primary"
            @click="submit()"
            >{{ $t('login.button') }}</v-btn
          >




        </v-form>
      </v-card-text>
    </v-card>

    <!-- <div class="text-center mt-6">
      {{ $t('login.noaccount') }}
      <router-link to="/auth/signup" class="font-weight-bold">
        {{ $t('login.create') }}
      </router-link>
    </div> -->
  </div>
</template>

<script>
/*
|---------------------------------------------------------------------
| Sign In Page Component
|---------------------------------------------------------------------
|
| Sign in template for user authentication into the application
|
*/
export default {
  data() {
    return {
      // sign in buttons
      isLoading: false,
      isSignInDisabled: false,

      // form
      isFormValid: true,
      email: '',
      password: '',
      Role: [
        {
          name: this.$i18n.t("login.provider"),
          value: "PROVIDER",
        },
        {
          name: this.$i18n.t("login.client"),
          value: "CLIENT",
        },
      ],
      Type: [
        {
          name: this.$i18n.t("login.email"),
          value: "email",
        },
        {
          name: this.$i18n.t("ProviderEdit.Phone"),
          value: "phone",
        },
      ],
      credentials: {
        Phone: '',
        email: '',
        password: '',
        Role: '',
        Type: '',
      },
      // form error
      error: false,
      errorMessages: '',

      errorProvider: false,
      errorProviderMessages: '',

      // show password field
      showPassword: false,

      providers: [
        {
          id: 'google',
          label: 'Google',
          isLoading: false
        },
        {
          id: 'facebook',
          label: 'Facebook',
          isLoading: false
        }
      ],

      // input rules
      rules: {
        required: (value) => (value && Boolean(value)) || 'Required'
      }
    }
  },
  methods: {
    async login(credentials) {
      if (!this.$refs.form.validate()) {
        return
      } else {
        try {
          await this.$store.dispatch('login', credentials)
          this.$router.push({
            path: '/'
          })
          history.pushState(null, null, null)
          window.addEventListener('popstate', function () {
            history.pushState(null, null, null)
          })
          setTimeout('location.reload(true)', 100)
        } catch (e) {
          return e
        }
      }
    },
    submit() {
      if (this.$refs.form.validate()) {
        this.isLoading = true
        this.isSignInDisabled = true
        this.login(this.credentials)
        setTimeout(() => {
          this.isLoading = false
          this.isSignInDisabled = false
        }, 2000)
      }
    },

    signInProvider(provider) {},
    resetErrors() {
      this.error = false
      this.errorMessages = ''

      this.errorProvider = false
      this.errorProviderMessages = ''
    }
  }
}
</script>
